
function _playButton_action () {
    iTunes.play();
    update();
}
function _pauseButton_action () {
    iTunes.pause();
    update();
}
function _reverseButton_action () {
    if (rewindDelay.ticking) {
        rewindDelay.ticking = false;
        iTunes.backTrack();
    }
    else
        iTunes.resume();
    update();
}
function _reverseButton_initAction () {
    rewindDelay.ticking = true;
}
function _reverseButton_enterAction () {
    if (!rewindDelay.ticking) {
        iTunes.rewind();
        update();
    }
}
function _reverseButton_exitAction () {
    if (currentStatus.player = "rewinding") {
        iTunes.resume();
        update();
    }
}
function _forwardButton_action () {
    if (ffDelay.ticking) {
        ffDelay.ticking = false;
        iTunes.nextTrack();
    }
    else
        iTunes.resume();
    update();
}
function _forwardButton_initAction () {
    ffDelay.ticking = true;
}
function _forwardButton_enterAction () {
    if (!ffDelay.ticking) {
        iTunes.fastForward();
        update();
    }
}
function _forwardButton_exitAction () {
    if (currentStatus.player = "fast forwarding") {
        iTunes.resume();
        update();
    }
}
function _volumeUp_action () {
    changeVolume(11);
}
function _volumeDown_action () {
    changeVolume(-11);
}

function _positionFrame_initAction () {
    this.highlight();
    skinElements.transport_dot.highlight();
}
function _positionFrame_endAction () {
    this.unhighlight();
    skinElements.transport_dot.unhighlight();
}
function _positionFrame_action (x, y) {
    var hBase = this.hOffset + this.dotOffset;
    var x = x - 1 - hBase;
    currentStatus.position = Math.round(currentTrack.time * x / this.movementRange);
    iTunes.playerPosition = currentStatus.position;
    setTrackTime();
}

function _volumeIndicator_action (x, y) {
    setVolume(Math.round(100 * (x - this.hOffset) / this.width));
}
function _ratingStars_action (x, y) {
    setRating(Math.round(5 * (x - this.hOffset + 4) / this.width));
}


skinSelectorClose.action = function () {
    skin_window.visible = false;
}
skinSelectorClose.isActive = function () { return true; };


/************ Using Images as Buttons **************/

function _button_mouseDown () {
    if (this.isActive()) {
        if (this.initAction)
            this.initAction(system.event.hOffset, system.event.vOffset);
        this.mouseDown = true;
        this.highlight();
        return true;
    }
    return false;
}

function _button_mouseEnter () {
    this.mouseOver = true;
    if (this.isActive() && this.mouseDown) {
        if (this.enterAction)
            this.enterAction(system.event.hOffset, system.event.vOffset);
        this.highlight();
        return true;
    }
    return false;
}

function _button_mouseExit () {
    this.mouseOver = false;
    if (this.isActive() && this.mouseDown) {
        if (this.exitAction)
            this.exitAction(system.event.hOffset, system.event.vOffset);
        this.unhighlight();
        return true;
    }
    return false;
}

function _button_mouseUp () {
    this.mouseDown = false;
    if (this.isActive() && this.mouseOver) {
        if (this.action)
            this.action(system.event.hOffset, system.event.vOffset);
        this.unhighlight();
        return true;
    }
    return false;
}



/******* Using Images as scrub controls *******/

function _scrub_mouseDown () {
    if (this.isActive()) {
        if (this.initAction)
            this.initAction(system.event.hOffset, system.event.vOffset);
        this.action(system.event.hOffset, system.event.vOffset);
        this.mouseDown = true;
        return true;
    }
    return false;
}

function _scrub_mouseMove () {
    if (this.isActive() && this.mouseDown) {
        this.action(system.event.hOffset, system.event.vOffset);
        return true;
    }
    return false;
}

function _scrub_mouseUp () {
    this.mouseDown = false;
    if (this.isActive()) {
        if (this.endAction)
            this.endAction();
        return true;
    }
    return false;
}








/******** Additions to Image.prototype *********/

Image.prototype.isActive = function () {
    return !this.inactive && !suspended;
}

Image.prototype.highlight = function () {
    if (this.activeSrc)
        this.src = this.activeSrc;
    else
        this.hslAdjustment = "0, 0, -50";
}

Image.prototype.unhighlight = function () {
    if (this.normalSrc)
        this.src = this.normalSrc;
    this.hslAdjustment = null;
}



