var skinGroupButtons;
var skinListButtons;
var selectedSkinGroup = -1;
var selectedSkin = -1;

function addSkinGroup() {
    var newGroup = prompt("Name:", "untitled group", "Create Group", "Create");
    if (!newGroup)
        return;
    var newGroupPath = skinsFolder + "/" + newGroup;
    print(newGroupPath);
    filesystem.createDirectory(newGroupPath);
    var n = skinGroupButtons.length;
    skinGroupButtons[n] = new ListButton({name: newGroup, path: newGroupPath},
                                         n, "group", groupFrame);
}

function buildSkinGroupList() {
    var searchPaths = [ skinsFolder ];
    selectedSkinGroup = -1;
    var groups = new Array();
    for (i in searchPaths) {
        var folders = filesystem.getDirectoryContents(searchPaths[i]);
        for (f in folders) {
            var folder = searchPaths[i] + "/" + folders[f];
            print("Scanning folder " + folder);
            if (filesystem.isDirectory(folder) &&
                folder.substr(-7) != ".bundle")
                groups.push({name: folders[f], path: folder });
        }
    }
    for (i in skinGroupButtons) {
        skinGroupButtons[i].text.removeFromSuperview();
    }
    skinGroupButtons = new Array();
    var n = 0;
    var currentGroup = parentDirectory(preferences.skinPath.value);
    for (g in groups) {
        skinGroupButtons[n] = new ListButton(groups[g], n, "group", groupFrame);
        if (groups[g]["path"] == currentGroup) {
            selectSkinGroup(n);
        }
        n++;
    }
}

function parentDirectory(path) {
    return path.substr(0, path.lastIndexOf("/"));
}

function buildSkinList(path) {
    var folders = filesystem.getDirectoryContents(path);
    selectedSkin = -1;
    var skins = new Array();
    for (i in folders) {
        var folder = path + "/" + folders[i]
        if (checkSkinInfo(folder))
            skins.push({name: folders[i], path: folder});
    }
    for (i in skinListButtons) {
        skinListButtons[i].text.removeFromSuperview();
    }
    skinListButtons = new Array();
    var n = 0;
    for (s in skins) {
        skinListButtons[n] = new ListButton(skins[s], n, "skin", skinFrame);
        if (skins[s]["path"] == preferences.skinPath.value) {
            skinListButtons[n].select();
            selectedSkin = n;
        }
        n++;
    }
}

function checkSkinInfo(path) {
    var skinInfo =  path + "/Skin Info.xml";
    return filesystem.itemExists(skinInfo);
}


function ListButton(info, i, type, parent) {
    this.id = i;
    this.text = new Text()
    this.text.font = "Lucida Grande, Arial";
    this.text.size = 11;
    this.text.vOffset = 14 * (i+1);
    this.text.width = 186;
    this.text.truncation = "end";
    this.text.data = " " + info["name"];
    this.path = info["path"];
    this.text.onMouseDown = (type=="group"?"selectSkinGroup":"selectSkin") + "(" + i + ")";
    if (type == "group") {
        this.text.onDragEnter = "skinGroupButtons["+i+"].dragEnter(system.event.data)";
        this.text.onDragExit = "skinGroupButtons["+i+"].dragExit()";
        this.text.onDragDrop = "skinGroupButtons["+i+"].dragDrop()";
    }
    var contextMenu = new Array()
    contextMenu[0] = new MenuItem();
    contextMenu[0].title = "Reveal in " + (system.platform=="macintosh"?"Finder":"Explorer");
    contextMenu[0].onSelect = "filesystem.reveal(" + quotePath(this.path) + ")";
    this.text.contextMenuItems = contextMenu;
    parent.addSubview(this.text);
}

function quotePath(path) {
    return '"' + resolvePath(path).replace(/"/g, '\\"') + '"';
}


ListButton.prototype.select = function () {
    this.text.bgColor = "#0033DD";
    this.text.bgOpacity = 200;
    this.text.color = "#FFFFFF";
}
ListButton.prototype.deselect = function () {
    this.text.bgOpacity = 0;
    this.text.color = "#000000";
}

ListButton.prototype.dragEnter = function (data) {
    if (data[0] == "filenames") {
        this.dragData = new Array();
        for (var i = 1; i < data.length; i++)
            if (checkSkinInfo(data[i]))
                this.dragData.push(data[i]);
        if (this.dragData.length > 0)
            this.select();
    }
}
ListButton.prototype.dragExit = function () {
    if (this.id != selectedSkinGroup)
        this.deselect();
}
ListButton.prototype.dragDrop = function () {
    if (this.dragData.length > 0) {
        for (i in this.dragData)
            if (!filesystem.copy(this.dragData[i], this.path))
                alert("Error installing skin " + this.dragData[i] + "\n\nA skin with the same name may already exist.");
        selectSkinGroup(this.id);
    }
}

function selectSkinGroup(i) {
    if (selectedSkinGroup >= 0)
        skinGroupButtons[selectedSkinGroup].deselect();
    skinGroupButtons[i].select();
    selectedSkinGroup = i;
    buildSkinList(skinGroupButtons[i].path);
}

function selectSkin(i) {
    if (selectedSkin >= 0)
        skinListButtons[selectedSkin].deselect();
    skinListButtons[i].select();
    selectedSkin = i;
    preferences.skinPath.value = skinListButtons[i].path;
    createGUI(true);
}
