/* Konfabulator JS Command Line
   Author: Daniel Dickison (danieldickison@cmu.edu)
   Requires Konfabulator version 2+
   April 3, 2005
*/

function CommandLine() {
    var window = new Window("CommandLine");
    window.onGainFocus = "commandLine.text.focus();";
    window.onContextMenu = "commandLine.makeMenu()";
    this.window = window;
    
    var bg = new Image();
    bg.src = "Resources/CommandLineBG.png";
    bg.window = window;
    this.bg = bg;
    
    var textArea = new TextArea();
    textArea.data = "";
    textArea.hOffset = 9;
    textArea.vOffset = 8;
    textArea.lines = 1;
    textArea.width = 289;
    textArea.font = "Bitstream Vera Sans Mono, Monaco";
    textArea.size = 11;
    textArea.color = "#CCD9E6";
    textArea.window = window;
    textArea.spellcheck = false;
    textArea.onKeyDown = "commandLine.keyPress(system.event.keyString)";
    textArea.onContextMenu = "commandLine.makeMenu()";
    this.text = textArea;
    
    this.history = new Array();
    this.historyIndex = -1;
    
    window.height = 32;
    window.width = 316;
    window.visible = 1;
    if (window.vOffset < 30)
        window.vOffset = 30;
}

CommandLine.prototype.keyPress = function (key) {
    //print(key);
    switch (key) {
        case "Return":
        case "Enter":
            this.execute();
            break;
        case "DownArrow":
            this.historyNext();
            break;
        case "UpArrow":
            this.historyPrev();
            break;
    }
}

CommandLine.prototype.makeMenu = function () {
    var items = new Array();
    var item;
    for (i in this.history) {
        item = new MenuItem();
        item.title = this.history[i];
        item.onSelect = "commandLine.text.data = '" + item.title.replace(/'/g, "\\'") + "'";
        items.push(item);
    }
    if (items.length == 0) {
        items[0] = new MenuItem();
        items[0].title = "History is empty";
        items[0].onSelect = "";
        items[0].enabled = false;
    }
    this.window.contextMenuItems = items;
}

CommandLine.prototype.execute = function () {
    this.text.rejectKeyPress();
    var cmd = this.text.data.replace(/[\r\n]/g, "");
    try {
        print("["+this.history.length+"] " + cmd);
        print(eval(cmd));
    }
    finally {
        this.historyIndex = this.history.push(cmd);
        this.text.data = "";
    }
}

CommandLine.prototype.historyNext = function () {
    if (this.historyIndex < this.history.length) {
        this.historyIndex++;
        if (this.historyIndex >= this.history.length)
            this.text.data = "";
        else
            this.text.data = this.history[this.historyIndex];
    }
}

CommandLine.prototype.historyPrev = function () {
    if (this.historyIndex > 0) {
        this.historyIndex--;
        this.text.data = this.history[this.historyIndex];
    }
    else
        beep();
}

var commandLine = new CommandLine();

function inspect (obj) {
    for (i in obj)
        print(i + ": " + obj[i]);
}

