function iTunesTrack() {
    this.clear();
}

iTunesTrack.prototype.update = function () {
    var updated = false;
    var newVal;
    for (var i in this._fieldMap) {
        newVal = this._fieldMap[i]();
        if (this[i] != newVal) {
            this[i] = newVal;
            updated = true;
        }
    }
    return updated;
}

iTunesTrack.prototype.clear = function () {
    for (var i in this._fieldDefaults) {
        this[i] = this._fieldDefaults[i];
    }
}


var _iTunesTrack_getTrackNumber;
var _iTunesTrack_getTrackCount;

if (system.platform == "macintosh") {
    _iTunesTrack_getTrackNumber = function () {
        return telliTunes("tell current track to return the track number");
    }
    _iTunesTrack_getTrackCount = function () {
        return telliTunes("tell current track to return the track count");
    }
}
else { // system.platform == "windows"
    // TODO: implement these with COM!
    _iTunesTrack_getTrackNumber = function () {
        return iTunesCOM().CurrentTrack.TrackNumber;
    }
    _iTunesTrack_getTrackCount = function () {
        return iTunesCOM().CurrentTrack.TrackCount;
    }
}

iTunesTrack.prototype._fieldMap = {
    artist: function () { return iTunes.trackArtist; },
    album: function () { return iTunes.trackAlbum; },
    title: function () { return iTunes.trackTitle; },
    type: function () { return iTunes.trackType; },
    time: function () { return iTunes.trackLength; },
    rating: function () {return iTunes.trackRating; },
    number: _iTunesTrack_getTrackNumber,
    count: _iTunesTrack_getTrackCount
}

iTunesTrack.prototype._fieldDefaults = {
    artist: "",
    album: "",
    title: "",
    type: "",
    time: 0,
    number: "0",
    count: "0"
}
